
#include<iostream>
#include<fstream>
#include<cstdlib>

using namespace std;

#include"defo.h"
#include"multiint.h"
#include"kspolbds.h"
#include"zgfiles.h"

// 17.VIII.2009 - currently this file contains two very related classes
//  Poly_Bds i KuraShi_Tail - KuraShi_Tail is richer, I need to glue them into one
// class


// Bounds
Poly_Bds::Poly_Bds(int p_m, int p_BIG_M,int p_s, interval p_c,const interval pa[])
{
  m=p_m;
  Big_M=p_BIG_M;
  s=p_s;
  c=p_c;
  #ifdef BORLAND
  try{
  #endif
    a= new interval[Big_M+1];
    remove_a=1;
    for(int i=1;i<=Big_M;i++)
      a[i]=pa[i];
  #ifdef BORLAND
  }
  catch(xalloc){
    cerr << "PolyBds::PolyBds - cannot allocate " << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  #endif
}

Poly_Bds::Poly_Bds(int p_m, int p_BIG_M)
{
  m=p_m;
  Big_M=p_BIG_M;
  c=0;
  s=0;
  #ifdef BORLAND
  try{
  #endif
    a= new interval[Big_M+1];
    remove_a=1;
    for(int i=1;i<=Big_M;i++)
      a[i]=0.0;
  #ifdef BORLAND
  }
  catch(xalloc){
    cerr << "PolyBds::PolyBds - cannot allocate " << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  #endif
}

void Poly_Bds::reset(int p_m,int p_Big_M)
{
  if(remove_a){
    delete [] a;
    a=NULL;
  }

  m=p_m;
  Big_M=p_Big_M;
  c=0;
  s=0;
  #ifdef BORLAND
  try{
  #endif
    a= new interval[Big_M+1];
    remove_a=1;
    for(int i=1;i<=Big_M;i++)
      a[i]=0.0;
  #ifdef BORLAND
  }
  catch(xalloc){
    cerr << "PolyBds::reset - cannot allocate " << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  #endif
}



Poly_Bds::Poly_Bds( int p_m, int p_Big_M,const Poly_Bds &initbds)
{
  if(p_Big_M < initbds.Big_M){ // this will require computation of c - to cover
                    // the range i=p_Big_M+1,\dots, initbds.Big_M
    cerr << "PolyBds::PolyBds - must be p_Big_M >= initbds.Big_M " << endl;
    cerr << " and it is: p_Big_M = " << p_Big_M << " initbds.Big_M=" << initbds.Big_M << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  m=p_m;
  Big_M=p_Big_M;
  c=initbds.c;
  s=initbds.s;
  #ifdef BORLAND
  try{
  #endif
    a= new interval[Big_M+1];
    remove_a=1;
    for(int i=1;i<=Big_M;i++)
      a[i]=initbds(i);
  #ifdef BORLAND
  }
  catch(xalloc){
    cerr << "PolyBds::PolyBds - cannot allocate " << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  #endif
}


Poly_Bds::Poly_Bds(const Poly_Bds &initbds)
{
  m=initbds.m;
  Big_M=initbds.Big_M;
  c=initbds.c;
  s=initbds.s;
  #ifdef BORLAND
  try{
  #endif
    a= new interval[Big_M+1];
    remove_a=1;
    for(int i=1;i<=Big_M;i++)
      a[i]=initbds(i);
  #ifdef BORLAND
  }
  catch(xalloc){
    cerr << "PolyBds::PolyBds - cannot allocate " << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  #endif
}




void Poly_Bds::newvalues(int p_m, int p_BIG_M,const Poly_Bds &bds)
{
 if(p_BIG_M < bds.Big_M){ // this will require computation of c - to cover
                    // the range i=p_Big_M+1,\dots, initbds.Big_M
    cerr << "PolyBds::newvalues - must be p_BIG_M >= bds.Big_M " << endl;
    cerr << " and it is: p_Big_M = " << p_BIG_M << " bds.Big_M=" << bds.Big_M << endl;
    #if defined(WIN95) && defined(KRAK)
      waitBt();
    #endif
    exit(EXIT_FAILURE);
 }
 if(p_BIG_M != Big_M){
    if(!remove_a){
      cerr << "Error - Poly_Bds::newvalues " << endl;
       #if defined(KRAK) && defined(WIN95)
                     waitBt();
    #endif
      exit(EXIT_FAILURE);
    }
    delete [] a;
    a=NULL;
    #ifdef BORLAND
    try{
    #endif
      a= new interval[p_BIG_M+1];
    #ifdef BORLAND
    }
    catch(xalloc){
      cerr << "PolyBds::newvalues - cannot allocate " << endl;
      #if defined(WIN95) && defined(KRAK)
        waitBt();
      #endif
      exit(EXIT_FAILURE);
    }
    #endif
    remove_a=1;
  }

  m=p_m;
  Big_M=p_BIG_M;
  c=bds.c;
  s=bds.s;
  for(int i=1;i<=Big_M;i++)
    a[i]=bds(i);
}


void Poly_Bds::newvalues(int p_m, int p_BIG_M,int p_s, interval p_c,const interval pa[])
{
  if(p_BIG_M != Big_M){
    if(!remove_a){
      cerr << "Error - Poly_Bds::newvalues " << endl;
       #if defined(KRAK) && defined(WIN95)
                     waitBt();
    #endif
      exit(EXIT_FAILURE);
    }
    delete [] a;
    a=NULL;
    #ifdef BORLAND
    try{
    #endif
      a= new interval[p_BIG_M+1];
    #ifdef BORLAND
    }
    catch(xalloc){
      cerr << "PolyBds::newvalues - cannot allocate " << endl;
      #if defined(WIN95) && defined(KRAK)
        waitBt();
      #endif
      exit(EXIT_FAILURE);
    }
    #endif
    remove_a=1;
  }
  m=p_m;
  Big_M=p_BIG_M;
  c=p_c;
  s=p_s;
  for(int i=1;i<=Big_M;i++)
    a[i]=pa[i];
}

void Poly_Bds::newvalues(const Poly_Bds &p)
{
  newvalues(p.m,p.Big_M,p.s,p.c,p.a);
}

Poly_Bds::~Poly_Bds()
{
  if(remove_a)
    delete [] a;
}

interval Poly_Bds::operator()(int i) const
    //  returns i-th coordinate
{
  interval res;
  if(i<=Big_M) res=a[i];
  else res=interval(-1,1)*c/power(interval(i),s);
  return res;
}


void Poly_Bds::save(ostream &report, const char comment[]) const
// saves in a text format
{
  report << "---------------" << endl;
  report << comment << endl;
  report << "m=" << m << "  M=" << Big_M << endl;
  saveAllCoord(report,a,Big_M,1,(Big_M >6) );
  report << "tail: " << c.right_b() << "/k^" << s << endl;
}

void Poly_Bds::save(char fname[], const char comment[]) const
// saves in a text format
{
  ofstream report(fname,ios::app);
  save(report,comment);
}

void Poly_Bds::multiply(interval t)
// this*=t;
{
  for(int i=1;i<=Big_M;i++)
    a[i]*=t;

  c=Right(abs(t* c));
}



///////////////

void KuraShi_Tail::newvalues(int p_m, int p_BIG_M,int p_s, interval p_c, interval pa[])
{
  if(p_BIG_M != big_m){
    if(!remove_a){
      cerr << "Error - KuraShi_Tail::newvalues " << endl;
      #if defined(WIN95) && defined(KRAK)
        cerr << "press any key " << endl;
        waitBt();
      #endif
      exit(EXIT_FAILURE);
    }
    delete [] a;
    a= new interval[p_BIG_M+1];
    remove_a=1;
  }
  m=p_m;
  big_m=p_BIG_M;
  c=Right(p_c);
  s=p_s;
  for(int i=m+1;i<=big_m;i++)
    a[i]=pa[i];
}


KuraShi_Tail::KuraShi_Tail(int p_m, int p_BIG_M,int p_s, interval p_c, interval pa[])
{
  m=p_m;
  big_m=p_BIG_M;
  s=p_s;
  c=Right(p_c);
  a= new interval[big_m+1];
  remove_a=1;
  for(int i=m+1;i<=big_m;i++)
    a[i]=pa[i];

}

KuraShi_Tail::KuraShi_Tail(int p_m, int p_BIG_M)
{
  m=p_m;
  big_m=p_BIG_M;
  c=0;
  s=0;
  a= new interval[big_m+1];
  for(int i=m+1;i<=big_m;i++)
    a[i]=0.0;
  remove_a=1;
}

KuraShi_Tail::KuraShi_Tail()
{
  m=0;
  big_m=0;
  a=NULL;
  c=0;
  s=0;
  remove_a=1;
}

KuraShi_Tail::KuraShi_Tail(const KuraShi_Tail &source)
{
  m=source.m;
  big_m=source.big_m;
  s=source.s;
  c=Right(source.c);
  a= new interval[big_m+1];
  remove_a=1;
  for(int i=m+1;i<=big_m;i++)
    a[i]=source.a[i];
}

KuraShi_Tail & KuraShi_Tail::operator=(const KuraShi_Tail &source)
{
  newvalues(source.m,source.big_m,source.s,source.c,source.a);
  return *this;
}


KuraShi_Tail::~KuraShi_Tail()
{
  if(remove_a)
    delete [] a;
}

interval KuraShi_Tail::operator()(int i)  const
    //  returns i-th coordinate
{
  interval res=0;
  if((m < i) && (i<=big_m)) res=a[i];
  else {
    interval t=Right(c/power(interval(i),s));
    res=interval(-t.right_b(),t.right_b());
  }
  return res;
}


void KuraShi_Tail::multiply(interval t)
// this*=t;
{
  for(int i=m+1;i<=big_m;i++)
    a[i]*=t;

  c=Right(abs(t* c));
}


int KuraShi_Tail::subset(const KuraShi_Tail &T)   const
       // return 1, when this \subset T
{
  int ret=1;
  if((m != T.m) || (big_m!=T.big_m)){
    cerr << "KuraShi_Tail::subset - dimensions don't match " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  int i=m+1;
  while(ret && (i<=big_m)){
    ret=in(a[i],T.a[i],0);
    i++;
  }
  if(c!=0){ // this means that we have a nonzero fartail
    if(ret)
      ret=(T.s <= s);
    if(ret){ // here we need to be carreful, in case of good powers
      // we cant just evaluate this(M+1) and T(M+1) and compare Right()
      // but we need Right(this(M+1)) <= Left(possible upper bound of T(M+1)
      //  this is especially important when both tails are identical
      if(T.s==s){
        ret=(Right(c) <= Right(T.c));
      } else{
        interval thist=c/power(interval(big_m+1),s);
        interval tt=Right(T.c)/power(interval(T.big_m+1),T.s);
        ret=(Right(thist) <= Left(tt));
      }
    }
  }
  return ret;
}


void KuraShi_Tail::inflatediam(interval t)
// on output - this(i)=center(this(i) old value) + t*(-1,1)*old diameter this->(i)
{
  t=Right(abs(t));
  for(int i=m+1;i<=big_m;i++)
     a[i]=inflate(a[i],t);

  c=Right(abs(t* c));
}

void KuraShi_Tail::newfartail(interval aMp1,int ns)
    // we set a new value for the far tail, such that s(new)=ns
    //  and T(M+1) >= aMp1 (in fact we do it with some margin)
    //   to make sure that for some more efficient schemes of computation
    // compution of aMp1=C/(M+1)^{s} (from some other tail)
    //   it will still hold
{
  if(big_m>0){
    interval nc;
    aMp1=Right(abs(aMp1));
    if(aMp1 >0){
      interval one_plus=1+1e-7;
      nc=Right(one_plus*aMp1*power(interval(big_m+1),ns));
      interval naMp1=Right(nc/power(interval(big_m+1),ns));
      while(!(naMp1 > aMp1)){
        nc=Right(one_plus*nc);
        naMp1=Right(nc/power(interval(big_m+1),ns));
      }
    }else{
      nc=0; // this is an empty tail, but for some reason we want
            // some power
    }
    c=nc;
    s=ns;
  }
}

void KuraShi_Tail::decpower(int d)
// we increase the far tail, so that the new bound is given by C(new)/k^{s-d};
// hence the new s is equal to s-d
{

  if((big_m>0) && (s>0) && (d>0) && (s - d >1)){
    interval aMp1=Right(c/power(interval(big_m+1),s));
    newfartail(aMp1,s-d);
  }
}


void KuraShi_Tail::save(ostream &report,int howtowrite, const char comment[]) const
// if howtowrite == 3, then it is a program form
// otherwise is 'text' form:
//      howtowrite=1 - standard interval format, =2 - mid point + [-d,d]
{
  if((howtowrite < 1) || (howtowrite >3)){
    howtowrite=1;
  }
  report << comment << endl;
  report << "m=" << m << "  M=" << big_m << endl;
  #ifdef BORLAND
  long prevf=report.setf(ios::scientific);
  #else
  std::_Ios_Fmtflags  prevf=report.setf(ios::scientific);
  #endif
  for(int i=m+1;i<=big_m;i++){
    if(howtowrite==3){
      report << "a[" << i << "]=interval(";
      report << a[i].left_b() << ", " << a[i].right_b() ;
      report << ");" << endl;
    }else{
      report << "(" << i << ")";
      writeinterval(report,a[i],howtowrite);
      if((i % 2==0) && (i!=big_m)) report << endl;
    }
  }
  report << endl;

  report << "Far tail: " << c.right_b() << "/k^" << s ;
  report << "   a[" << (big_m+1) << "]=";
  writeinterval(report,interval(-1,1)*c/power(interval(big_m+1),s),1);;
  report << endl;
  report.flush();
  report.setf(prevf);
}



void KuraShi_Tail::savebin(FILE *fbin) const
{
  fwrite(&m,sizeof(int),1,fbin);
  fwrite(&big_m,sizeof(int),1,fbin);
  fwrite(a+m+1,sizeof(interval),big_m-m,fbin);
  fwrite(&c,sizeof(interval),1,fbin);
  fwrite(&s,sizeof(int),1,fbin);
}


int KuraShi_Tail::readbin(FILE *fbin)
{
  int ret=1;
  int pm,pbigM,ps;
  interval pc;
  interval *pa;
  fread(&pm,sizeof(int),1,fbin);
  fread(&pbigM,sizeof(int),1,fbin);
  if(pbigM > pm){
    pa=new interval[pbigM+1];
    fread(pa+pm+1,sizeof(interval),pbigM-pm,fbin);

    fread(&pc,sizeof(interval),1,fbin);
    fread(&ps,sizeof(int),1,fbin);

    newvalues(pm,pbigM,ps,pc,pa);

    delete [] pa;
  }else{
    ret=0;
  }
  return ret;
}



void KuraShi_Tail::kssymm()
// applies the R-symmetry to the tail variables
             // a_{2k}->a_{2k},  a_{2k+1}-> -a_{2k+1}
{
  for(int i=m+1;i<=big_m;i++){
    if(i % 2==1)
      a[i]=-a[i];
  }
}

void KS_Tail_hull(const KuraShi_Tail & T1,const KuraShi_Tail &T2, KuraShi_Tail &T)
//  on output T ; such that T_1 \cup T_2 \subset T
{
  if((T1.m != T2.m) || (T1.big_m!=T2.big_m)){
    cerr << "KS_Tail_hull() - dimensions don't match " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  int pm=T1.m;
  int pbig_m=T1.big_m;
  interval *pa;
  pa=new interval[pbig_m+1];
  for(int i=pm+1;i<=pbig_m;i++)
    pa[i]=Ihull(T1(i),T2(i));


  int ps;
  interval pc;
  if(T1.s==T2.s){ // we treat this situation differently, beacause we
      // want that if T1=T2, then its hull is T1
      // this is why we don't want to recompute T.c from T1(M+1)
    ps=T1.s;
    pc=Right(T1.c);
    if(Right(T2.c)>pc) pc=Right(T2.c);

  } else{
  ps=T1.s;
  if(ps==0)  // this is possible if there is no tail (zero tail)
    ps=T2.s;

  if(ps > T2.s) ps=T2.s;

  interval T1M1=T1(pbig_m+1);
  interval T2M1=T2(pbig_m+1);

  interval temp=power(interval(pbig_m+1),ps);
  interval pc1=Right(T1M1*temp);
  interval pc2=Right(T2M1*temp);
  if(pc2 > pc1) pc=pc2;
  else pc=pc1;
  }
  T.newvalues(pm,pbig_m,ps,pc,pa);

  delete [] pa;

}

int commonpart(const KuraShi_Tail & T1, const KuraShi_Tail &T2, KuraShi_Tail &T)
//  on output 1 is returned if T_1 \cap T_2 \nonempty
//             and T becomes an upper bound for  T_1 \cap T_2
//                 (obtaining the exact intersection is imposible for far tail)
// otherwise 0 is returned and T is unchanged
{
  int ret=1;
  if((T1.m != T2.m) || (T1.big_m!=T2.big_m)){
    cerr << "commonpart(KuraShi_Tail ) - dimensions don't match " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  int pm=T1.m;
  int pbig_m=T1.big_m;
  interval *pa;
  pa=new interval[pbig_m+1];
  for(int i=pm+1;i<=pbig_m;i++)
    ret=ret && commonpart(T1.a[i],T2.a[i],pa+i);


  // for the far tail the intersection is always non-empty
  interval pc=Right(T1.c);
  int ps=T1.s;
  if(T2.s > ps){ // the far tail of T2 is decaying faster, so we take is
                 // as the bound for the intersection
    ps=T2.s;
    pc=T2.c;
  }
  if(T2.s==T1.s){
    if(pc>Right(T2.c)) pc=Right(T2.c);
  }

  if(ret) T.newvalues(pm,pbig_m,ps,pc,pa);

  delete [] pa;
  return ret;
}

